 #-*- coding: latin-1 -*-
 #GRAAFI JA SELLE ELEMENTIDE MOODUL
 #Autor: Jri Kiho
__version__ = "3.1" 
class Tipp:
        """ Klass nimega Tipp """ 
         #Isendivli:
        def __init__(self):
                self.nimi = '' #selle tipu nimi (mrgend[x;y])
         #Isendimeetodid:
        def margend(self): #selle tipu mrgend
                if "[" in self.nimi:
                        k = self.nimi.index("[") 
                        return self.nimi[0: k] 
                return self.nimi 
        def seadaMargend(self, m): #m selle tipu mrgendiks
                s = self.nimi 
                if "[" in s:
                        k = s.index("[") 
                        self.nimi = m + s[k:] 
                else:
                        self.nimi = m 
        def x(self): #selle tipu x-koordinaat
                k = self.nimi.index("[") 
                s = self.nimi[k+1:] 
                k = s.index(";") 
                s = s[0:k] 
                return int(s) 
        def y(self): #selle tipu y-koordinaat
                k = self.nimi.index("[") 
                s = self.nimi[k+1:] 
                k = s.index(";") 
                k1 = s.index("]") 
                s = s[k+1:k1] 
                return int(s) 
        def seadaKoordinaadid(self, x, y): #x ja y selle tipu koordinaatideks
                s = self.nimi 
                if ("[" in s):
                        k = s.index("[") 
                        s = self.nimi[0: k]; 
                self.nimi = s + "[" + str(x) + ";" + str(y) + "]" 
        def seadaVli(self, vljaNimi, vljaVrtus):
                 #Antud: vljaNimi, mille vrtust soovitakse muuta
                 #.          ja omistatav (uus) vrtus - vljaVrtus
                 #Tulemus: antud nimega vljale omistatakse antud vrtus.
                 #.             Kui antud nimega vlja selle tipu mrgendis ei ole,
                 #.             siis lisatakse antud nime ja antud vrtusega vli.
                ss = self.nimi.split(';') 
                for i in range(len(ss)):
                        vli = ss[i] 
                        if vli.startswith(vljaNimi+'='):
                                vv = vli.split('=') 
                                v = '='.join([vv[0], vljaVrtus]) 
                                ss.pop(i) 
                                ss.insert(i, v) 
                                self.nimi = ';'.join(ss) 
                                return 
                self.nimi = vljaNimi + "=" + vljaVrtus + ";" + self.nimi 
        def vli(self, vljaNimi):
                 #Antud: vlja nimi
                 #Tulemus: tagastatakse selle tipu nimest osa,
                 #.                     mis paikneb "vljaNimi=" ja semikooloni vahel;
                 #.              None, kui antud nimega vlja tipunimes ei ole
                ss = self.nimi.split(';') 
                for vli in ss:
                        if vli.startswith(vljaNimi+'='):
                                vv = vli.split('=') 
                                return vv[1] 
                return None 
class Kaar:
        """ Klass nimega Kaar """ 
         #Isendivljad:
        def __init__(self):
                self.algusTipp = Tipp() #selle kaare algustipp
                self.lppTipp   = Tipp() #selle kaare lpptipp
                self.nimi = '' #selle kaare nimi e. mrgend
class Graaf:
        """ Klass nimega Graaf """ 
         #Isendivljad:
        def __init__(self):
                self.tipud  = [] #selle graafi tipud
                self.kaared = [] #selle graafi kaared
         #Isendimeetodid:
        def lisadaTipp(self, tipp):
                 #Antud: tipp -- isend klassist Tipp
                 #Tulem: antud tipp lisatud selle graafi tippude jrjendisse
                self.tipud.append(tipp) 
        def lisadaKaar(self, kaar):
                 #Antud: kaar -- isend klassist Kaar
                 #Tulem: antud kaar lisatud selle graafi kaarte jrjendisse
                 #NB! Ei kontrollita, kas antud kaare algus ja lpptipp (juba) kuuluvad selle graafi tippude hulka
                self.kaared.append(kaar) 
        def toString(self):
                 #Tagastab selle graafi tabelesituses -- iga rida vastab hele tipule:
                 #tipuNr) tipunimi  k1 k2 ... \n
                 #.               kus ki kirjeldab tipust vljuvat i-ndat kaart kujul
                 #.               kaarenimi --> kaarelpptipuNr
                tulem = '\n'; 
                for i,ti in enumerate(self.tipud): #for i in range(n)
                        tulem += str(i+1) + ") " + ti.nimi; 
                        for kj in  self.kaared: #for j in range(m)
                                if (kj.algusTipp == ti):
                                        tulem += " " + kj.nimi + " --> " + str(self.tipuNr(kj.lppTipp)); 
                        tulem += "\n"; 
                return tulem 
        def sisendaste(self, t):
                 #Antud: selle graafi tipp t
                 #Tulem: tagastatakse kaarte arv, mis suubuvad tippu t
                loe = 0 
                for k in self.kaared:
                        if (k.lppTipp == t):loe += 1 
                return loe 
        def n(self):
                 #Tagastatakse selle graafi tippude arv
                return len(self.tipud) 
        def m(self):
                 #Tagastatakse selle graafi kaarte arv
                return len(self.kaared) 
        def tippNr(self, i):
                 #Tagastatakse selle graafi tipp nr i (NB! Graafi esimene tipp on numbriga 1);
                 #kui sellise numbriga tippu ei ole, tagastatakse thiviit None
                if i < 1 or i > self.n():
                        return None 
                return self.tipud[i-1] 
        def otsidaKaar(self, tipp1, tipp2):
                 #Tagastatakse selle graafi kaar (tipp1; tipp2);
                 #kui sellist kaart ei ole, tagastatakse thiviit None
                for k in self.kaared:
                        if (k.algusTipp == tipp1) and (k.lppTipp == tipp2):
                                return k 
                return None 
        def tipuNr(self, tipp):
                 #Tagastatakse antud tipu number selles graafis (0, kui tipp pole selles graafis)
                if (tipp in self.tipud):
                        return self.tipud.index(tipp) + 1 
                return 0 
        def aste(self, t):
                 #Antud: selle graafi tipp t
                 #Tulemus: tagastatakse t vljundaste -- kaarte arv, mis lhtuvad tipust t
                loe = 0 
                for k in self.kaared:
                        if (k.algusTipp == t):loe += 1 
                return loe 
        def naabertipud(self, tipp):
                 #Tagastatakse antud tipust lhtuvate kaarte lpptippude jrjend
                tulem = [] 
                for k in self.kaared:
                        if (k.algusTipp == tipp):tulem.append(k.lppTipp) 
                return tulem 
        def valjuvadKaared(self, tipp):
                 #Tagastatakse antud tipust vljuvate kaarte jrjend
                tulem = [] 
                for k in self.kaared:
                        if (k.algusTipp == tipp):tulem.append(k) 
                return tulem 
        def eemaldadaTipp(self, tipp):
                 #Sellest graafist eemaldatakse antud tipp;
                 #kui antud tippu selles graafis ei olnud, siis ei tehta midagi
                if self.tipuNr(tipp) == 0:
                        return 
                i = 0 
                while i < len(self.kaared):
                        k = self.kaared[i] 
                        if k.algusTipp == tipp or k.lppTipp == tipp:self.kaared.remove(k) 
                        else:i += 1 
                self.tipud.remove(tipp) 
        def eemaldadaKaar(self, tipp1, tipp2):
                 #Sellest graafist eemaldatakse antud kaar tipp1-->tipp2;
                 #kui seda kaart selles graafis ei olnud, siis ei tehta midagi
                k = self.otsidaKaar(tipp1, tipp2) 
                if k != None:
                        self.kaared.remove(k) 
        ''' 
        ------- Meetodid, kui see graaf on kahendpuu: ------- 
        ''' 
         #Eeldus: kahendpuu juureks on graafi tipp nr 1
        def lisadaAlluv(self, ylemus, alluv, vasakule):
                 #Antud: kaks tippu, ylemus ja alluv ning tevrtus vasakule
                 #Tulemus: tipp alluv lisatud tipule ylemus
                 #.                                      vasakuks alluvaks, kui vasakule = True
                 #.                                      paremaks alluvaks, kui vasakule = False
                 #Eeldus: lisamise vimalikkus on kontrollitud: lemusel vastav alluv puudub
                nihe = 2 
                self.lisadaTipp(alluv); 
                kaar = Kaar() 
                kaar.algusTipp = ylemus 
                kaar.lppTipp = alluv 
                self.lisadaKaar(kaar); 
                x = ylemus.x(); 
                y = ylemus.y(); 
                if (vasakule):alluv.seadaKoordinaadid(x-nihe, y+nihe) 
                else:alluv.seadaKoordinaadid(x+nihe, y+nihe) 
                return alluv 
        def jarglased(self, t):
                 #Antud: tipp t
                 #Tulemus: tulemus[0] = t vasak alluv vi None,
                 #.             tulemus[1] = t parem alluv vi None
                tulemus = [None, None] 
                for k in self.kaared:
                        algus = k.algusTipp 
                        lopp = k.lppTipp 
                        if (algus == t):
                                if (lopp.x() < t.x()):tulemus[0] = lopp; 
                                else:tulemus[1] = lopp; 
                return tulemus 
        def vasakAlluv(self, t):
                 #Tagastatakse tipu t vasak alluv selles graafis
                return self.jarglased(t)[0] 
        def paremAlluv(self, t):
                 #Tagastatakse tipu t parem alluv selles graafis
                return self.jarglased(t)[1] 
        def faili(self, fNimi):
                 #Selle graafi tabelkuju kirjutamine faili fNimi
                f = open(fNimi, 'w') 
                f.write(self.toString()) 
                f.close() 
 #Klassimeetodid:
def graafTabelesitusest(s):
         #Antud: sne s - graaf tabelesituses (nagu tagastatakse funktsioonist toString())
         #Tulem: luuakse ja tagastatakse vastav graafi isend
        tulem = Graaf() 
        rida = s.strip().split('\n') #tabelesituse read
        n = len(rida) #ridade arv (= tippude arv)
        tipujarjend = [] 
        for i in range(n): #n tippu tipujrjendisse
                x = Tipp() 
                tipujarjend.append(x) 
                tulem.lisadaTipp(x) 
        for i in range(n):
                ridas = rida[i] 
                k = ridas.find(')') 
                ridas = ridas[k+1:].strip(); #ilma "nr)"
                 #tipu nimi:
                tipuNimi = '' 
                kv = ridas.find('>') 
                if (kv == -1):
                        tipuNimi = ridas; 
                        tipujarjend[i].nimi = tipuNimi; 
                else:
                        if (len(ridas) == 0):
                                tipuNimi = '' 
                        else:
                                ktyh = ridas.find(' ') 
                                tipuNimi = ridas[0: ktyh] 
                                ridas = ridas[ktyh+1:].strip(); #ilma tipu nimeta
                                tipujarjend[i].nimi = tipuNimi 
                                kaars = ridas.split('>'); 
                                kaaremargend = kaars[0][0: len(kaars[0])-2].strip(); 
                                for j in range(len(kaars)-1):
                                         #kaaremrgend on eelmisest (j-1) olemas
                                        osa = kaars[j+1].strip(); 
                                         #osa: "nr mrgend --" vi
                                         #"nr --" vi
                                         #"nr"
                                        if (osa.endswith('--')):
                                                osa = osa[0: len(osa)-2].strip(); #"--" lpust ra
                                        ktyh = osa.find(' ') 
                                        kuhu = ''; 
                                        if (ktyh == -1):
                                                kuhu = osa; 
                                        else:
                                                kuhu = osa[0: ktyh]; 
                                        lopptipp = tipujarjend[int(kuhu) -1] #tipp[Integer.parseInt(kuhu)-1];
                                        kr = Kaar(); 
                                        kr.nimi = kaaremargend; 
                                        kr.algusTipp = tipujarjend[i]; 
                                        kr.lppTipp = lopptipp 
                                        tulem.lisadaKaar(kr) 
                                        kaaremargend = osa[len(kuhu):].strip(); 
        return tulem 
def graafFailist(fNimi):
         #Graafi sisestamine tabelkujust failis fNimi
        f = open(fNimi, 'r') 
        s = "".join(f.readlines()) 
        f.close() 
        return graafTabelesitusest(s) 
if __name__ == '__main__':
        #testNr = 2 #vli tipu nimes
        testNr = 3 #kahendpuu
        if testNr == 2: #vli tipu nimes
                print ("------------------------------ TEST " + str(testNr)) 
                graaf = Graaf() 
                tipp1 = Tipp(); tipp1.seadaMargend("A") 
                tipp2 = Tipp(); tipp2.seadaMargend("B") 
                graaf.lisadaTipp(tipp1) 
                graaf.lisadaTipp(tipp2) 
                t2 = graaf.tippNr(2) 
                print ("MARGEND", t2.margend()) 
                v = t2.vli("xxx") 
                print ("xxx=", v) 
                t2.seadaVli("yyy", "XYZ") 
                print ("MARGEND", t2.margend()) 
                v = t2.vli("yyy") 
                print ("yyy=", v) 
                t2.seadaVli("w", "-99") 
                print ("MARGEND", t2.margend()) 
                v = t2.vli("yyy") 
                print ("yyy=", v) 
                v = t2.vli("w") 
                print ("w=", v) 
                t2.seadaVli("w", "1000") 
                print ("MARGEND", t2.margend()) 
                v = t2.vli("w") 
                print ("w=", v) 
        if testNr == 3: #kahendpuu
                print ("------------------------------ TEST " + str(testNr)) 
                kp = graafFailist("kpuu.txt") 
                print ("Vaadeldav graaf tabelina:") 
                print (kp.toString()) 
                def print_eesj(tipp):
                        if tipp == None:
                                return 
                        print (tipp.margend(), end = " ") 
                        print_eesj(kp.vasakAlluv(tipp)) 
                        print_eesj(kp.paremAlluv(tipp)) 
                print ("Tipud eesjarjestuses:") 
                print_eesj(kp.tipud[0]) 
                print () 
        print ("-----------------------------------------.") 
